/*Elkulator v0.7 by Tom Walker
  Memory handling*/
#include "sdlalleg.h"
#include <stdio.h>
#include "elk.h"

int FASTLOW=0;
int FASTHIGH2=0;
//#define FASTLOW (turbo || (mrb && mrbmode && mrbmapped))
#define FASTHIGH (FASTHIGH2 && ((pc&0xE000)!=0xC000))

int output,timetolive;
int mrbmapped=0;
unsigned char readkeys(unsigned short addr);
unsigned char ram[32768],ram2[32768];
unsigned char os[16384],mrbos[16384];
unsigned char basic[16384],adfs[16384],dfs[16384];
char rom12[16384],rom13[16384];

void loadroms()
{
        FILE *f=fopen("os","rb");
        fread(os,16384,1,f);
        fclose(f);
        f=fopen("os300.rom","rb");
        fread(mrbos,16384,1,f);
        fclose(f);
        f=fopen("basic.rom","rb");
        fread(basic,16384,1,f);
        fclose(f);
        f=fopen("adfs.rom","rb");
        fread(adfs,16384,1,f);
        fclose(f);
        f=fopen("dfs.rom","rb");
        fread(dfs,16384,1,f);
        fclose(f);
}

void loadcart(char *fn)
{
        FILE *f=fopen(fn,"rb");
        fread(rom12,16384,1,f);
        fclose(f);
}

void loadcart2(char *fn)
{
        FILE *f=fopen(fn,"rb");
        fread(rom13,16384,1,f);
        fclose(f);
}

void unloadcart()
{
        memset(rom12,0,16384);
        memset(rom13,0,16384);
}

void dumpram()
{
        FILE *f=fopen("ram.dmp","wb");
        fwrite(ram,32768,1,f);
        fclose(f);
}

void resetmem()
{
        FASTLOW=turbo;
        FASTHIGH2=(mrb && mrbmode==2);
}

unsigned char readmem(unsigned short addr)
{
        if (addr<0x2000)
        {
                if (FASTLOW) return ram2[addr];
                waitforramsync();
                cycles++;
                return ram[addr];
        }
        if (addr<0x8000)
        {
                if (FASTHIGH) return ram2[addr];
                waitforramsync();
                cycles++;
                return ram[addr];
        }
        if (addr<0xC000)
        {
                if (!extrom)
                {
                        if (intrombank&2) return basic[addr&0x3FFF];
                        return readkeys(addr);
                }
                if (rombank==0xC) return rom12[addr&0x3FFF];
                if (rombank==0xD) return rom13[addr&0x3FFF];
                if (rombank==0xF && plus3 && adfsena) return adfs[addr&0x3FFF];
                if (rombank==0x3 && plus3 && dfsena)  return dfs[addr&0x3FFF];
//                if (rombank==0) return game[addr&0x3FFF];
                return addr>>8;
        }
        if ((addr&0xFF00)==0xFC00 || (addr&0xFF00)==0xFD00)
        {
                if ((addr&0xFFF8)==0xFCC0 && plus3) return read1770(addr);
                return addr>>8;
        }
        if ((addr&0xFF00)==0xFE00) return readula(addr);
        if (mrb) return mrbos[addr&0x3FFF];
        return os[addr&0x3FFF];
}

unsigned short pc;
void writemem(unsigned short addr, unsigned char val)
{
        if (addr<0x2000)
        {
                if (FASTLOW) ram2[addr]=val;
                else
                {
                        waitforramsync();
                        cycles++;
                        ram[addr]=val;
                }
                return;
        }
        if (addr<0x8000)
        {
                if (FASTHIGH)
                {
                        ram2[addr]=val;
                        return;
                }
                waitforramsync();
                cycles++;
                ram[addr]=val;
                return;
        }
        if (addr<0xC000)
        {
                if (extrom && rombank==0x3 && plus3 && dfsena) dfs[addr&0x3FFF]=val;
        }
        if ((addr&0xFF00)==0xFE00) writeula(addr,val);
        if ((addr&0xFFF8)==0xFCC0 && plus3) write1770(addr,val);
        if (addr==0xFC7F && mrb)
        {
                FASTLOW=(turbo || (mrb && mrbmode && mrbmapped));
                FASTHIGH2=(mrb && mrbmode==2);
        }
}

int keys[2][14][4]=
{
        {
                {KEY_RIGHT,KEY_END,0,KEY_SPACE},
                {KEY_LEFT,KEY_DOWN,KEY_ENTER,KEY_DEL},
                {KEY_MINUS,KEY_UP,KEY_QUOTE,0},
                {KEY_0,KEY_P,KEY_COLON,KEY_SLASH},
                {KEY_9,KEY_O,KEY_L,KEY_STOP},
                {KEY_8,KEY_I,KEY_K,KEY_COMMA},
                {KEY_7,KEY_U,KEY_J,KEY_M},
                {KEY_6,KEY_Y,KEY_H,KEY_N},
                {KEY_5,KEY_T,KEY_G,KEY_B},
                {KEY_4,KEY_R,KEY_F,KEY_V},
                {KEY_3,KEY_E,KEY_D,KEY_C},
                {KEY_2,KEY_W,KEY_S,KEY_X},
                {KEY_1,KEY_Q,KEY_A,KEY_Z},
                {KEY_ESC,KEY_ALT,KEY_LCONTROL,KEY_LSHIFT}
        },
        {
                {KEY_RIGHT,KEY_END,0,KEY_SPACE},
                {KEY_LEFT,KEY_DOWN,KEY_ENTER,KEY_BACKSPACE},
                {KEY_MINUS,KEY_UP,KEY_QUOTE,0},
                {KEY_0,KEY_P,KEY_SEMICOLON,KEY_SLASH},
                {KEY_9,KEY_O,KEY_L,KEY_STOP},
                {KEY_8,KEY_I,KEY_K,KEY_COMMA},
                {KEY_7,KEY_U,KEY_J,KEY_M},
                {KEY_6,KEY_Y,KEY_H,KEY_N},
                {KEY_5,KEY_T,KEY_G,KEY_B},
                {KEY_4,KEY_R,KEY_F,KEY_V},
                {KEY_3,KEY_E,KEY_D,KEY_C},
                {KEY_2,KEY_W,KEY_S,KEY_X},
                {KEY_1,KEY_Q,KEY_A,KEY_Z},
                {KEY_ESC,KEY_TILDE,KEY_RCONTROL,KEY_RSHIFT}
        }
};

unsigned char readkeys(unsigned short addr)
{
        int c;
        unsigned char temp=0;
        for (c=0;c<14;c++)
        {
                if (!(addr&(1<<c)))
                {
                        if (key[keys[0][c][0]]) temp|=1;
                        if (key[keys[0][c][1]]) temp|=2;
                        if (key[keys[0][c][2]]) temp|=4;
                        if (key[keys[0][c][3]]) temp|=8;
                        if (key[keys[1][c][0]]) temp|=1;
                        if (key[keys[1][c][1]]) temp|=2;
                        if (key[keys[1][c][2]]) temp|=4;
                        if (key[keys[1][c][3]]) temp|=8;
                }
        }
        return temp;
}
