/*Elkulator v0.7 by Tom Walker
  Windows main loop*/
#include "sdlalleg.h"
//#define WIN32_LEAN_AND_MEAN
#define BITMAP WINDOWS_BITMAP
#include <windows.h>
#undef BITMAP
#include "SDL_syswm.h"
#include "elk.h"

#include "resources.h"

int tapespeed;
int fullscreen=0;
int gotofullscreen=0;
HWND      ghwnd;
HINSTANCE ghinstance;
HMENU     ghmenu;

int plus3=0;
int dfsena=0,adfsena=0;
int turbo=0;
int mrb=0,mrbmode=0;
int drawmode=0;

char discname[260];
char discname2[260];

void setmenu(HMENU m)
{
	RECT ClientArea;
	GetClientRect( ghwnd, &ClientArea);

	SetMenu( ghwnd, m);

	RECT NewClientArea;
	GetClientRect( ghwnd, &NewClientArea);

	/* check if we've lost pixels */
	if(NewClientArea.bottom != ClientArea.bottom)
	{
		/* fix up */
		RECT WindowArea;
		GetWindowRect( ghwnd, &WindowArea);
		WindowArea.bottom += ClientArea.bottom - NewClientArea.bottom;

		MoveWindow( ghwnd, WindowArea.left, WindowArea.top, WindowArea.right - WindowArea.left, WindowArea.bottom - WindowArea.top, TRUE);
	}
}

void getwindowsstuff()
{
        SDL_SysWMinfo sysinfo;
        SDL_VERSION(&sysinfo.version);
        if (SDL_GetWMInfo(&sysinfo)==1)
        {
                ghwnd=sysinfo.window;
                ghinstance=GetModuleHandle(NULL);
                ghmenu = LoadMenu(ghinstance,TEXT("MainMenu"));
                setmenu(ghmenu);
                SDL_EventState(SDL_SYSWMEVENT, SDL_ENABLE);
        }
        SDL_WM_SetCaption("Elkulator v0.7","Elkulator");
}


int getfn(HWND hwnd, char *f, char *s, int save, char *de)
{
        char fn[512];
        char start[512];
        OPENFILENAME ofn;
        fn[0]=0;
        start[0]=0;
//        strcpy(fn,s);
//        rpclog("getfn - file %s filter %s\n",fn,f);
        ZeroMemory(&ofn, sizeof(ofn));
        ofn.lStructSize = sizeof(ofn);
        ofn.hwndOwner = hwnd;
        ofn.lpstrFile = fn;
        ofn.nMaxFile = 260;
        ofn.lpstrFilter = f;//"All\0*.*\0Text\0*.TXT\0";
        ofn.nFilterIndex = 1;
        ofn.lpstrFileTitle = NULL;
        ofn.nMaxFileTitle = 0;
        ofn.lpstrInitialDir = NULL;
        ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_OVERWRITEPROMPT | 0x10000000;//OFN_FORCESHOWHIDDEN;
        ofn.lpstrDefExt=de;
        if (save)
        {
                if (GetSaveFileName(&ofn))
                {
                        strcpy(s,fn);
                        return 0;
                }
        }
        else
        {
                if (GetOpenFileName(&ofn))
                {
                        strcpy(s,fn);
                        return 0;
                }
        }
        return -1;
}

void handlemenu(SDL_SysWMmsg *msg)
{
        char s[512];
        int c;
        switch (msg->wParam)
        {
                case IDM_FILE_RESET:
                waitforthread();
                resetit=1;
                stopwaiting();
                break;
                case IDM_FILE_EXIT:
                quited=1;
                break;
                case IDM_TAPE_LOAD:
                if (!getfn(msg->hwnd,"All tape files (*.UEF;*.CSW)\0*.UEF;*.CSW\0UEF Tape Image (*.UEF)\0*.UEF\0All\0*.*\0\0",tapename,0,"UEF"))
                {
                        c=strlen(tapename);
                        while (tapename[c]!='.' && c>0) c--;
                        c++;
                        if (tapename[c]=='c' || tapename[c]=='C')
                        {
                                opencsw(tapename);
                        }
                        else
                        {
                                openuef(tapename);
                        }
//                        saveconfig();
                }
                resetsound();
                cleardrawit();
                infocus=1;
//                rpclog("Focus back on!\n");
                break;
                case IDM_TAPE_REWIND:
                if (cswena) opencsw(tapename);
                else        openuef(tapename);
                break;
                case IDM_DISC_PLUS3:
                waitforthread();
                plus3^=1;
                CheckMenuItem(ghmenu,IDM_DISC_PLUS3,(plus3)?MF_CHECKED:MF_UNCHECKED);
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_DISC_ADFS:
                waitforthread();
                adfsena^=1;
                CheckMenuItem(ghmenu,IDM_DISC_ADFS,(adfsena)?MF_CHECKED:MF_UNCHECKED);
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_DISC_DFS:
                waitforthread();
                dfsena^=1;
                CheckMenuItem(ghmenu,IDM_DISC_DFS,(dfsena)?MF_CHECKED:MF_UNCHECKED);
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_OTHER_TURBO:
                waitforthread();
                turbo^=1;
                CheckMenuItem(ghmenu,IDM_OTHER_TURBO,(turbo)?MF_CHECKED:MF_UNCHECKED);
                if (turbo)
                {
                        mrb=0;
                        CheckMenuItem(ghmenu,IDM_OTHER_MRB,MF_UNCHECKED);
                }
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_OTHER_MRB:
                waitforthread();
                mrb^=1;
                CheckMenuItem(ghmenu,IDM_OTHER_MRB,(mrb)?MF_CHECKED:MF_UNCHECKED);
                if (mrb)
                {
                        turbo=0;
                        CheckMenuItem(ghmenu,IDM_OTHER_TURBO,MF_UNCHECKED);
                }
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_MRB_OFF:
                case IDM_MRB_TURBO:
                case IDM_MRB_SHADOW:
                waitforthread();
                mrbmode=msg->wParam-IDM_MRB_OFF;
                CheckMenuItem(ghmenu,IDM_MRB_OFF,(mrbmode==0)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_MRB_TURBO,(mrbmode==1)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_MRB_SHADOW,(mrbmode==2)?MF_CHECKED:MF_UNCHECKED);
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_DISC_LOAD1:
                if (discchanged[0]) savedisc(discname,0);
                if (!getfn(msg->hwnd,"Disc Image (*.ADF;*.ADL;*.SSD;*.DSD)\0*.ADF;*.ADL;*.SSD;*.DSD\0DFS Single Sided Disc Image (*.SSD)\0*.SSD\0DFS Double Sided Disc Image (*.DSD)\0*.DSD\0ADFS Disc Image (*.ADF;*.ADL)\0*.ADF;*.ADL\0All files (*.*)\0*.*\0\0",discname,0,"ADF"))
                   loaddisc(discname,0);
                resetsound();
                cleardrawit();
                infocus=1;
                break;
                case IDM_DISC_LOAD2:
                if (discchanged[1]) savedisc(discname,1);
                if (!getfn(msg->hwnd,"Disc Image (*.ADF;*.ADL;*.SSD;*.DSD)\0*.ADF;*.ADL;*.SSD;*.DSD\0DFS Single Sided Disc Image (*.SSD)\0*.SSD\0DFS Double Sided Disc Image (*.DSD)\0*.DSD\0ADFS Disc Image (*.ADF;*.ADL)\0*.ADF;*.ADL\0All files (*.*)\0*.*\0\0",discname2,0,"ADF"))
                   loaddisc(discname2,1);
                resetsound();
                cleardrawit();
                infocus=1;
                break;
                case IDM_ROM_LOAD1:
                s[0]=0;
                if (!getfn(msg->hwnd,"ROM Image (*.ROM)\0*.ROM\0All\0*.*\0\0",s,0,"ROM"))
                {
                        waitforthread();
                        loadcart(s);
                        reset6502();
                        resetula();
                        stopwaiting();
                }
                resetsound();
                cleardrawit();
                infocus=1;
                break;
                case IDM_ROM_LOAD2:
                s[0]=0;
                if (!getfn(msg->hwnd,"ROM Image (*.ROM)\0*.ROM\0All\0*.*\0\0",s,0,"ROM"))
                {
                        waitforthread();
                        loadcart2(s);
                        reset6502();
                        resetula();
                        stopwaiting();
                }
                resetsound();
                cleardrawit();
                infocus=1;
                break;
                case IDM_ROM_UNLOAD:
                waitforthread();
                unloadcart();
                reset6502();
                resetula();
                stopwaiting();
                break;
                case IDM_VIDEO_SCANLINES:
                case IDM_VIDEO_LINEDBL:
                case IDM_VIDEO_2XSAI:
                case IDM_VIDEO_SCALE2X:
                case IDM_VIDEO_EAGLE:
                case IDM_VIDEO_PAL:
                drawmode=msg->wParam-IDM_VIDEO_SCANLINES;
                clear();
                CheckMenuItem(ghmenu,IDM_VIDEO_SCANLINES,(drawmode==0)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_VIDEO_LINEDBL,(drawmode==1)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_VIDEO_2XSAI,(drawmode==2)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_VIDEO_SCALE2X,(drawmode==3)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_VIDEO_EAGLE,(drawmode==4)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_VIDEO_PAL,(drawmode==5)?MF_CHECKED:MF_UNCHECKED);
                break;
                case IDM_VIDEO_FULLSCREEN:
                gotofullscreen=1;
//                set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 512, 0, 0);
//                reloadmenu=1;
                break;
                case IDM_SPD_NORMAL:
                case IDM_SPD_FAST:
                case IDM_SPD_REALLY:
                tapespeed=msg->wParam-IDM_SPD_NORMAL;
                CheckMenuItem(ghmenu,IDM_SPD_NORMAL,(tapespeed==0)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_SPD_FAST,  (tapespeed==1)?MF_CHECKED:MF_UNCHECKED);
                CheckMenuItem(ghmenu,IDM_SPD_REALLY,(tapespeed==2)?MF_CHECKED:MF_UNCHECKED);
                break;

                default:
                return;
        }
        cleardrawit();
        infocus=1;
        resetsound();
}

void initmenu()
{
        CheckMenuItem(ghmenu,IDM_DISC_PLUS3,(plus3)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_DISC_ADFS,(adfsena)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_DISC_DFS,(dfsena)?MF_CHECKED:MF_UNCHECKED);
        
        CheckMenuItem(ghmenu,IDM_OTHER_TURBO,(turbo)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_OTHER_MRB,(mrb)?MF_CHECKED:MF_UNCHECKED);
        
        CheckMenuItem(ghmenu,IDM_MRB_OFF,(mrbmode==0)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_MRB_TURBO,(mrbmode==1)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_MRB_SHADOW,(mrbmode==2)?MF_CHECKED:MF_UNCHECKED);

        CheckMenuItem(ghmenu,IDM_VIDEO_SCANLINES,(drawmode==0)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_VIDEO_LINEDBL,(drawmode==1)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_VIDEO_2XSAI,(drawmode==2)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_VIDEO_SCALE2X,(drawmode==3)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_VIDEO_EAGLE,(drawmode==4)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_VIDEO_PAL,(drawmode==5)?MF_CHECKED:MF_UNCHECKED);

        CheckMenuItem(ghmenu,IDM_SPD_NORMAL,(tapespeed==0)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_SPD_FAST,  (tapespeed==1)?MF_CHECKED:MF_UNCHECKED);
        CheckMenuItem(ghmenu,IDM_SPD_REALLY,(tapespeed==2)?MF_CHECKED:MF_UNCHECKED);
}

void runelk();

int main(int argc, char *argv[])
{
        int oldaltenter=0;
        allegro_init();
        getwindowsstuff();
        initelk();
        initmenu();
        startsdl(runelk);
        while (!quited && !((key[KEY_RCONTROL] | key[KEY_LCONTROL]) && key[KEY_ALT] && key[KEY_END]))
        {
                poll_sdl();
//                runelk();
                if (gotofullscreen || (!fullscreen && key[KEY_ALT] && key[KEY_ENTER] && !oldaltenter))
                {
                        gotofullscreen=0;
                        set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 512, 0, 0);
                        setmenu(NULL);
                        SDL_SetCursor(0);
                        fullscreen=1;
                        SDL_EventState(SDL_SYSWMEVENT, SDL_DISABLE);
                        key[KEY_ALT]=key[KEY_ENTER]=0;
                }
                else if (key[KEY_ALT] && key[KEY_ENTER] && fullscreen && !oldaltenter)
                {
                        fullscreen=0;
                        set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 512, 0, 0);
                        setmenu(ghmenu);
                        SDL_EventState(SDL_SYSWMEVENT, SDL_ENABLE);
                        key[KEY_ALT]=key[KEY_ENTER]=0;
                }
                oldaltenter=key[KEY_ALT] && key[KEY_ENTER];
        }
        closeelk();
        return 0;
}
END_OF_MAIN()
